diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/gpio.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/gpio.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/gpio.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/gpio.c	2012-05-12 19:38:20.732576829 +0200
@@ -19,12 +19,20 @@
 #include <linux/list.h>
 #include <linux/module.h>
 #include <linux/io.h>
+#include <linux/ipipe.h>
 
 #include <mach/hardware.h>
 #include <mach/at91_pio.h>
 #include <mach/gpio.h>
 
 #include <asm/gpio.h>
+#ifdef CONFIG_IPIPE
+#include <asm/irq.h>
+
+#ifdef __IPIPE_FEATURE_PIC_MUTE
+DEFINE_PER_CPU(__ipipe_irqbits_t, __ipipe_muted_irqs);
+#endif /* __IPIPE_FEATURE_PIC_MUTE */
+#endif /* CONFIG_IPIPE */
 
 #include "generic.h"
 
@@ -33,6 +41,10 @@
 	struct at91_gpio_chip	*next;		/* Bank sharing same clock */
 	struct at91_gpio_bank	*bank;		/* Bank definition */
 	void __iomem		*regbase;	/* Base of register bank */
+#ifdef CONFIG_IPIPE
+	unsigned *nonroot_gpios;
+	unsigned nonroot_gpios_storage;
+#endif
 };
 
 #define to_at91_gpio_chip(c) container_of(c, struct at91_gpio_chip, chip)
@@ -375,6 +387,10 @@
 
 static struct irq_chip gpio_irqchip = {
 	.name		= "GPIO",
+#ifdef CONFIG_IPIPE
+	.ack            = gpio_irq_mask,
+	.mask_ack       = gpio_irq_mask,
+#endif /* CONFIG_IPIPE */
 	.mask		= gpio_irq_mask,
 	.unmask		= gpio_irq_unmask,
 	.set_type	= gpio_irq_type,
@@ -394,6 +410,13 @@
 
 	/* temporarily mask (level sensitive) parent IRQ */
 	desc->chip->ack(irq);
+#ifdef CONFIG_IPIPE
+	if (!(*at91_gpio->nonroot_gpios)) {
+		local_irq_enable_hw();
+		local_irq_disable_hw();
+	}
+#endif /* CONFIG_IPIPE */
+
 	for (;;) {
 		/* Reading ISR acks pending (edge triggered) GPIO interrupts.
 		 * When there none are pending, we're finished unless we need
@@ -420,9 +443,15 @@
 					 * here to be disabled on the GPIO controller.
 					 */
 					gpio_irq_mask(pin);
+				} else {
+					ipipe_handle_chained_irq(pin);
+#ifdef CONFIG_IPIPE
+					if (!(*at91_gpio->nonroot_gpios)) {
+						local_irq_enable_hw();
+						local_irq_disable_hw();
+					}
+#endif /* CONFIG_IPIPE */
 				}
-				else
-					generic_handle_irq(pin);
 			}
 			pin++;
 			gpio++;
@@ -433,6 +462,79 @@
 	/* now it may re-trigger */
 }
 
+#if defined(CONFIG_IPIPE) && defined(__IPIPE_FEATURE_PIC_MUTE)
+void __ipipe_mach_enable_irqdesc(struct ipipe_domain *ipd, unsigned irq)
+{
+	struct irq_desc *desc = irq_to_desc(irq);
+
+	if (desc->chip == &gpio_irqchip) {
+		struct at91_gpio_chip *chip = &gpio_chip[(irq - PIN_BASE) / 32];
+		struct at91_gpio_bank *bank = chip->bank;
+
+		if (ipd != &ipipe_root && ++(*chip->nonroot_gpios) == 1)
+			__ipipe_irqbits[(bank->id / BITS_PER_LONG)]
+				&= ~(1 << (bank->id % BITS_PER_LONG));
+	}
+}
+
+void __ipipe_mach_disable_irqdesc(struct ipipe_domain *ipd, unsigned irq)
+{
+	struct irq_desc *desc = irq_to_desc(irq);
+	if (desc->chip == &gpio_irqchip) {
+		struct at91_gpio_chip *chip = &gpio_chip[(irq - PIN_BASE) / 32];
+		struct at91_gpio_bank *bank = chip->bank;
+
+		if (ipd != &ipipe_root && --(*chip->nonroot_gpios) == 0)
+			__ipipe_irqbits[(bank->id / BITS_PER_LONG)]
+				|= (1 << (bank->id % BITS_PER_LONG));
+	}
+}
+
+void ipipe_mute_pic(void)
+{
+	struct at91_gpio_chip *prev, *chip = NULL;
+	unsigned long unmasked, muted;
+	unsigned i;
+
+	for (i = 0; i < gpio_banks; i++) {
+		prev = chip;
+		chip = &gpio_chip[i];
+		if (!(*chip->nonroot_gpios))
+			continue;
+
+		unmasked = __raw_readl(chip->regbase + PIO_IMR);
+		muted = unmasked & __ipipe_irqbits[i + 1];
+		__raw_get_cpu_var(__ipipe_muted_irqs)
+			[i + PIN_BASE / 32] = muted;
+		__raw_writel(muted, chip->regbase + PIO_IDR);
+	}
+
+	unmasked = at91_sys_read(AT91_AIC_IMR);
+	muted = unmasked & __ipipe_irqbits[0];
+	__raw_get_cpu_var(__ipipe_muted_irqs)[0] = muted;
+	at91_sys_write(AT91_AIC_IDCR, muted);
+}
+
+void ipipe_unmute_pic(void)
+{
+	struct at91_gpio_chip *prev, *chip = NULL;
+	unsigned long muted;
+	unsigned i;
+
+	at91_sys_write(AT91_AIC_IECR, __raw_get_cpu_var(__ipipe_muted_irqs)[0]);
+	for (i = 0; i < gpio_banks; i++) {
+		prev = chip;
+		chip = &gpio_chip[i];
+		if (!(*chip->nonroot_gpios))
+			continue;
+
+		muted = __raw_get_cpu_var(__ipipe_muted_irqs)
+			[i + PIN_BASE / 32];
+		__raw_writel(muted, chip->regbase + PIO_IER);
+	}
+}
+#endif /* CONFIG_IPIPE && __IPIPE_FEATURE_PIC_MUTE */
+
 /*--------------------------------------------------------------------------*/
 
 #ifdef CONFIG_DEBUG_FS
@@ -631,13 +733,19 @@
 		at91_gpio->chip.base = PIN_BASE + i * 32;
 		at91_gpio->regbase = at91_gpio->bank->offset +
 			(void __iomem *)AT91_VA_BASE_SYS;
-
+#ifdef CONFIG_IPIPE
+		at91_gpio->nonroot_gpios = &at91_gpio->nonroot_gpios_storage;
+#endif
 		/* enable PIO controller's clock */
 		clk_enable(at91_gpio->bank->clock);
 
 		/* AT91SAM9263_ID_PIOCDE groups PIOC, PIOD, PIOE */
-		if (last && last->bank->id == at91_gpio->bank->id)
+		if (last && last->bank->id == at91_gpio->bank->id) {
 			last->next = at91_gpio;
+#ifdef CONFIG_IPIPE
+			at91_gpio->nonroot_gpios = last->nonroot_gpios;
+#endif
+		}
 		last = at91_gpio;
 
 		gpiochip_add(&at91_gpio->chip);
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/include/mach/hardware.h linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/include/mach/hardware.h
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/include/mach/hardware.h	2012-03-23 15:07:27.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/include/mach/hardware.h	2012-05-12 19:38:20.732576829 +0200
@@ -65,6 +65,25 @@
 #define AT91_VA_BASE_SYS	AT91_IO_P2V(AT91_BASE_SYS)
 #define AT91_VA_BASE_EMAC	AT91_IO_P2V(AT91RM9200_BASE_EMAC)
 
+#ifdef CONFIG_IPIPE
+#if defined(CONFIG_ARCH_AT91RM9200)
+#define AT91_BASE_TCB0 AT91RM9200_BASE_TCB0
+#elif defined(CONFIG_ARCH_AT91SAM9260) || defined(CONFIG_ARCH_AT91SAM9G20)
+#define AT91_BASE_TCB0 AT91SAM9260_BASE_TCB0
+#elif defined(CONFIG_ARCH_AT91SAM9261)
+#define AT91_BASE_TCB0 AT91SAM9261_BASE_TCB0
+#elif defined(CONFIG_ARCH_AT91SAM9263)
+#define AT91_BASE_TCB0 AT91SAM9263_BASE_TCB0
+#elif defined(CONFIG_ARCH_AT91SAM9RL)
+#define AT91_BASE_TCB0 AT91SAM9RL_BASE_TCB0
+#elif defined(CONFIG_ARCH_AT91X40)
+#define AT91_BASE_TCB0 (AT91_BASE_SYS + AT91_TC)
+#else
+#error "AT91 processor unsupported by Adeos"
+#endif
+#define AT91_VA_BASE_TCB0 AT91_IO_P2V(AT91_BASE_TCB0)
+#endif
+
  /* Internal SRAM is mapped below the IO devices */
 #define AT91_SRAM_MAX		SZ_1M
 #define AT91_VIRT_BASE		(AT91_IO_VIRT_BASE - AT91_SRAM_MAX)
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/include/mach/irqs.h linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/include/mach/irqs.h
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/include/mach/irqs.h	2012-03-20 16:42:30.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/include/mach/irqs.h	2012-05-12 19:38:20.732576829 +0200
@@ -45,4 +45,6 @@
 /* FIQ is AIC source 0. */
 #define FIQ_START AT91_ID_FIQ
 
+#define __IPIPE_FEATURE_PIC_MUTE
+
 #endif
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/include/mach/timex.h linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/include/mach/timex.h
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/include/mach/timex.h	2012-03-23 15:07:27.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/include/mach/timex.h	2012-05-12 19:38:20.732576829 +0200
@@ -87,6 +87,6 @@
 #define AT572D940HF_MASTER_CLOCK	80000000
 #define CLOCK_TICK_RATE		(AT572D940HF_MASTER_CLOCK/16)
 
-#endif
+#endif /* arch specific */
 
 #endif
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/irq.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/irq.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/irq.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/irq.c	2012-05-12 19:38:20.732576829 +0200
@@ -121,6 +121,9 @@
 	.name		= "AIC",
 	.ack		= at91_aic_mask_irq,
 	.mask		= at91_aic_mask_irq,
+#ifdef CONFIG_IPIPE
+	.mask_ack       = at91_aic_mask_irq,
+#endif /* CONFIG_IPIPE */
 	.unmask		= at91_aic_unmask_irq,
 	.set_type	= at91_aic_set_type,
 	.set_wake	= at91_aic_set_wake,
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/Kconfig linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/Kconfig
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/Kconfig	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/Kconfig	2012-05-12 19:38:20.736576829 +0200
@@ -433,6 +433,19 @@
 
 # ----------------------------------------------------------
 
+comment "Adeos I-pipe Options"
+
+config IPIPE_AT91_TC
+	depends on IPIPE
+	int "AT91 TC used as time base by Adeos I-pipe"
+	default 0
+	help
+	When Adeos interrupt pipeline is enabled, TC0 is used by default
+	as time base, but you can use TC1 or TC2 by setting this variable to 1
+	or 2. This should only be needed to avoid conflicts with other drivers.
+
+# ----------------------------------------------------------
+
 comment "AT91 Board Options"
 
 config MTD_AT91_DATAFLASH_CARD
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/Makefile linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/Makefile
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-at91/Makefile	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-at91/Makefile	2012-05-12 19:38:20.736576829 +0200
@@ -89,3 +89,14 @@
 ifeq ($(CONFIG_PM_DEBUG),y)
 CFLAGS_pm.o += -DDEBUG
 endif
+
+ifeq ($(CONFIG_IPIPE),y)
+obj-y := $(filter-out at91rm9200_time.o at91sam926x_time.o at91x40_time.o, $(obj-y))
+obj-$(CONFIG_ARCH_AT91RM9200)   += at91_ipipe_time.o
+obj-$(CONFIG_ARCH_AT91SAM9260)  += at91_ipipe_time.o
+obj-$(CONFIG_ARCH_AT91SAM9261)  += at91_ipipe_time.o
+obj-$(CONFIG_ARCH_AT91SAM9263)	+= at91_ipipe_time.o
+obj-$(CONFIG_ARCH_AT91SAM9RL)	+= at91_ipipe_time.o
+obj-$(CONFIG_ARCH_AT91SAM9G20)  += at91_ipipe_time.o
+obj-$(CONFIG_ARCH_AT91X40)	+= at91_ipipe_time.o
+endif
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/core.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/core.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/core.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/core.c	2012-05-12 19:38:20.736576829 +0200
@@ -2,6 +2,7 @@
  *  linux/arch/arm/mach-integrator/core.c
  *
  *  Copyright (C) 2000-2003 Deep Blue Solutions Ltd
+ *  Copyright (C) 2005 Stelian Pop.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2, as
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/include/mach/entry-macro.S linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/include/mach/entry-macro.S
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/include/mach/entry-macro.S	2012-03-20 16:42:30.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/include/mach/entry-macro.S	2012-05-12 19:38:20.736576829 +0200
@@ -29,7 +29,11 @@
 		teq	\irqstat, #0
 		ldreq	\irqstat, [\base, #(INTEGRATOR_HDR_IC_OFFSET+IRQ_STATUS)]
 		moveq	\irqnr, #IRQ_CIC_START
-
+#ifdef CONFIG_IPIPE
+		tst	\irqstat, #0x00000040			@ check IRQ_TIMERINT1 first
+		movne	\irqnr, #6
+		bne	1003f
+#endif /* CONFIG_IPIPE */
 1001:		tst	\irqstat, #15
 		bne	1002f
 		add	\irqnr, \irqnr, #4
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/include/mach/platform.h linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/include/mach/platform.h
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/include/mach/platform.h	2012-03-23 15:07:28.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/include/mach/platform.h	2012-05-12 19:38:20.736576829 +0200
@@ -390,7 +390,7 @@
  *  Timer definitions
  *
  *  Only use timer 1 & 2
- *  (both run at 24MHz and will need the clock divider set to 16).
+ *  (both run at 1MHZ on /CP and at 24MHz on /AP)
  *
  *  Timer 0 runs at bus frequency
  */
@@ -399,7 +399,11 @@
 #define INTEGRATOR_TIMER1_BASE          (INTEGRATOR_CT_BASE + 0x100)
 #define INTEGRATOR_TIMER2_BASE          (INTEGRATOR_CT_BASE + 0x200)
 
+#ifdef CONFIG_ARCH_INTEGRATOR_CP
+#define TICKS_PER_uSEC                  1
+#else
 #define TICKS_PER_uSEC                  24
+#endif
 
 /*
  *  These are useconds NOT ticks.
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/include/mach/timex.h linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/include/mach/timex.h
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/include/mach/timex.h	2012-03-20 16:42:30.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/include/mach/timex.h	2012-05-12 19:38:20.736576829 +0200
@@ -21,6 +21,6 @@
  */
 
 /*
- * ??
+ * Timer rate
  */
-#define CLOCK_TICK_RATE		(50000000 / 16)
+#define CLOCK_TICK_RATE		(1000000)
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/integrator_cp.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/integrator_cp.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-integrator/integrator_cp.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-integrator/integrator_cp.c	2012-05-12 19:38:20.736576829 +0200
@@ -2,6 +2,7 @@
  *  linux/arch/arm/mach-integrator/integrator_cp.c
  *
  *  Copyright (C) 2003 Deep Blue Solutions Ltd
+ *  Copyright (C) 2005 Stelian Pop.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -161,6 +162,9 @@
 	.name	= "CIC",
 	.ack	= cic_mask_irq,
 	.mask	= cic_mask_irq,
+#ifdef CONFIG_IPIPE
+	.mask_ack = cic_mask_irq,
+#endif /* CONFIG_IPIPE */
 	.unmask	= cic_unmask_irq,
 };
 
@@ -180,6 +184,9 @@
 	.name	= "PIC",
 	.ack	= pic_mask_irq,
 	.mask	= pic_mask_irq,
+#ifdef CONFIG_IPIPE
+	.mask_ack = pic_mask_irq,
+#endif /* CONFIG_IPIPE */
 	.unmask = pic_unmask_irq,
 };
 
@@ -199,6 +206,9 @@
 	.name	= "SIC",
 	.ack	= sic_mask_irq,
 	.mask	= sic_mask_irq,
+#ifdef CONFIG_IPIPE
+	.mask_ack = sic_mask_irq,
+#endif /* CONFIG_IPIPE */
 	.unmask	= sic_unmask_irq,
 };
 
@@ -218,7 +228,7 @@
 
 		irq += IRQ_SIC_START;
 
-		generic_handle_irq(irq);
+		ipipe_handle_chained_irq(irq);
 	} while (status);
 }
 
@@ -587,7 +597,7 @@
 	writel(0, TIMER1_VA_BASE + TIMER_CTRL);
 	writel(0, TIMER2_VA_BASE + TIMER_CTRL);
 
-	sp804_clocksource_init(TIMER2_VA_BASE);
+	sp804_clocksource_init(TIMER2_VA_BASE, INTEGRATOR_TIMER2_BASE);
 	sp804_clockevents_init(TIMER1_VA_BASE, IRQ_TIMERINT1);
 }
 
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-ixp4xx/common.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-ixp4xx/common.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-ixp4xx/common.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-ixp4xx/common.c	2012-05-12 19:38:20.736576829 +0200
@@ -44,6 +44,60 @@
 static void __init ixp4xx_clockevent_init(void);
 static struct clock_event_device clockevent_ixp4xx;
 
+#ifdef CONFIG_IPIPE
+#include <linux/ipipe.h>
+int __ipipe_mach_timerint = IRQ_IXP4XX_TIMER1;
+int __ipipe_mach_timerstolen = 0;
+unsigned int __ipipe_mach_ticks_per_jiffy = LATCH;
+EXPORT_SYMBOL(__ipipe_mach_timerint);
+EXPORT_SYMBOL(__ipipe_mach_timerstolen);
+EXPORT_SYMBOL(__ipipe_mach_ticks_per_jiffy);
+
+static int ixp4xx_timer_initialized;
+
+#define ONE_SHOT_ENABLE (IXP4XX_OST_ENABLE|IXP4XX_OST_ONE_SHOT)
+
+union tsc_reg {
+#ifdef __BIG_ENDIAN
+	struct {
+		unsigned long high;
+		unsigned long low;
+	};
+#else /* __LITTLE_ENDIAN */
+	struct {
+		unsigned long low;
+		unsigned long high;
+	};
+#endif /* __LITTLE_ENDIAN */
+	unsigned long long full;
+};
+
+#ifdef CONFIG_SMP
+static union tsc_reg tsc[NR_CPUS];
+
+void __ipipe_mach_get_tscinfo(struct __ipipe_tscinfo *info)
+{
+	info->type = IPIPE_TSC_TYPE_NONE;
+}
+
+#else /* !CONFIG_SMP */
+static union tsc_reg *tsc;
+
+void __ipipe_mach_get_tscinfo(struct __ipipe_tscinfo *info)
+{
+	info->type = IPIPE_TSC_TYPE_FREERUNNING;
+	info->u.fr.counter =
+		(unsigned *)
+		(IXP4XX_TIMER_BASE_PHYS + IXP4XX_OSTS_OFFSET);
+	info->u.fr.mask = 0xffffffff;
+	info->u.fr.tsc = &tsc->full;
+}
+#endif /* !CONFIG_SMP */
+
+static void ipipe_mach_update_tsc(void);
+
+#endif /* CONFIG_IPIPE */
+
 /*************************************************************************
  * IXP4xx chipset I/O mapping
  *************************************************************************/
@@ -268,8 +322,12 @@
 {
 	struct clock_event_device *evt = dev_id;
 
+#ifndef CONFIG_IPIPE
 	/* Clear Pending Interrupt by writing '1' to it */
 	*IXP4XX_OSST = IXP4XX_OSST_TIMER_1_PEND;
+#else /* CONFIG_IPIPE */
+	ipipe_mach_update_tsc();
+#endif /* CONFIG_IPIPE */
 
 	evt->event_handler(evt);
 
@@ -294,6 +352,14 @@
 	/* Reset time-stamp counter */
 	*IXP4XX_OSTS = 0;
 
+#ifdef CONFIG_IPIPE
+#ifndef CONFIG_SMP
+	tsc = (union tsc_reg *) __ipipe_tsc_area;
+	barrier();
+#endif /* CONFIG_SMP */
+
+	ixp4xx_timer_initialized = 1;
+#endif
 	/* Connect the interrupt handler and enable the interrupt */
 	setup_irq(IRQ_IXP4XX_TIMER1, &ixp4xx_timer_irq);
 
@@ -480,6 +546,13 @@
 	*IXP4XX_OSRT1 = osrt | opts;
 }
 
+#ifdef CONFIG_IPIPE
+int __ipipe_check_tickdev(const char *devname)
+{
+	return !strcmp(devname, clockevent_ixp4xx.name);
+}
+#endif /* CONFIG_IPIPE */
+
 static struct clock_event_device clockevent_ixp4xx = {
 	.name		= "ixp4xx timer1",
 	.features       = CLOCK_EVT_FEAT_PERIODIC | CLOCK_EVT_FEAT_ONESHOT,
@@ -501,3 +574,95 @@
 
 	clockevents_register_device(&clockevent_ixp4xx);
 }
+
+#ifdef CONFIG_IPIPE
+void __ipipe_mach_acktimer(void)
+{
+	/* Clear Pending Interrupt by writing '1' to it */
+	*IXP4XX_OSST = IXP4XX_OSST_TIMER_1_PEND;
+}
+
+static void ipipe_mach_update_tsc(void)
+{
+	union tsc_reg *local_tsc;
+	unsigned long stamp, flags;
+
+	local_irq_save_hw(flags);
+	local_tsc = &tsc[ipipe_processor_id()];
+	stamp = *IXP4XX_OSTS;
+	if (unlikely(stamp < local_tsc->low))
+		/* 32 bit counter wrapped, increment high word. */
+		local_tsc->high++;
+	local_tsc->low = stamp;
+	local_irq_restore_hw(flags);
+}
+
+notrace unsigned long long __ipipe_mach_get_tsc(void)
+{
+	if (likely(ixp4xx_timer_initialized)) {
+		union tsc_reg *local_tsc, result;
+		unsigned long stamp;
+
+		local_tsc = &tsc[ipipe_processor_id()];
+
+		__asm__ ("ldmia %1, %M0\n":
+			 "=r"(result.full): "r"(local_tsc), "m"(*local_tsc));
+		barrier();
+		stamp = *IXP4XX_OSTS;
+		if (unlikely(stamp < result.low))
+			/* 32 bit counter wrapped, increment high word. */
+			result.high++;
+		result.low = stamp;
+		return result.full;
+	}
+
+        return 0;
+}
+
+EXPORT_SYMBOL(__ipipe_mach_get_tsc);
+
+/*
+ * Reprogram the timer
+ *
+ * The timer is aperiodic (most of the time) when running Xenomai, so
+ * __ipipe_mach_set_dec is called for each timer tick and programs the
+ * timer hardware for the next tick.
+ *
+ */
+#define MIN_DELAY 333 /* 5 usec with the 66.66 MHz system clock */
+
+void __ipipe_mach_set_dec(unsigned long delay)
+{
+	if (delay > MIN_DELAY) {
+		*IXP4XX_OSRT1 = delay | ONE_SHOT_ENABLE;
+	} else {
+		ipipe_trigger_irq(IRQ_IXP4XX_TIMER1);
+	}
+}
+
+EXPORT_SYMBOL(__ipipe_mach_set_dec);
+
+/*
+ * This returns the number of clock ticks remaining.
+ */
+unsigned long __ipipe_mach_get_dec(void)
+{
+	return(*IXP4XX_OST1); /* remaining */
+}
+
+EXPORT_SYMBOL(__ipipe_mach_get_dec);
+
+void __ipipe_mach_release_timer(void)
+{
+	unsigned long flags;
+
+	local_irq_save_hw(flags);
+	ixp4xx_set_mode(clockevent_ixp4xx.mode, &clockevent_ixp4xx);
+	if (clockevent_ixp4xx.mode == CLOCK_EVT_MODE_ONESHOT)
+		ixp4xx_set_next_event(LATCH, &clockevent_ixp4xx);
+	local_irq_restore_hw(flags);
+}
+
+EXPORT_SYMBOL(__ipipe_mach_release_timer);
+
+#endif /* CONFIG_IPIPE */
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-ixp4xx/include/mach/platform.h linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-ixp4xx/include/mach/platform.h
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-ixp4xx/include/mach/platform.h	2012-03-20 16:42:30.000000000 +0100
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-ixp4xx/include/mach/platform.h	2012-05-12 19:38:20.736576829 +0200
@@ -150,10 +150,14 @@
 
 static inline void gpio_line_config(u8 line, u32 direction)
 {
+	unsigned long flags;
+
+	local_irq_save_hw(flags);
 	if (direction == IXP4XX_GPIO_IN)
 		*IXP4XX_GPIO_GPOER |= (1 << line);
 	else
 		*IXP4XX_GPIO_GPOER &= ~(1 << line);
+	local_irq_restore_hw(flags);
 }
 
 static inline void gpio_line_get(u8 line, int *value)
@@ -163,11 +167,14 @@
 
 static inline void gpio_line_set(u8 line, int value)
 {
+	unsigned long flags;
+
+	local_irq_save_hw(flags);
 	if (value == IXP4XX_GPIO_HIGH)
 	    *IXP4XX_GPIO_GPOUTR |= (1 << line);
 	else if (value == IXP4XX_GPIO_LOW)
 	    *IXP4XX_GPIO_GPOUTR &= ~(1 << line);
+	local_irq_restore_hw(flags);
 }
 
 #endif // __ASSEMBLY__
-
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx1/clock.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx1/clock.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx1/clock.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx1/clock.c	2012-05-12 19:38:20.736576829 +0200
@@ -596,7 +596,8 @@
 	clk_enable(&hclk);
 	clk_enable(&fclk);
 
-	mxc_timer_init(&gpt_clk, IO_ADDRESS(TIM1_BASE_ADDR), TIM1_INT);
+	mxc_timer_init(&gpt_clk, IO_ADDRESS(TIM1_BASE_ADDR),
+		       TIM1_BASE_ADDR, TIM1_INT);
 
 	return 0;
 }
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx2/clock_imx21.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx2/clock_imx21.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx2/clock_imx21.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx2/clock_imx21.c	2012-05-12 19:38:20.736576829 +0200
@@ -1234,6 +1234,6 @@
 #endif
 
 	mxc_timer_init(&gpt_clk[0], MX21_IO_ADDRESS(MX21_GPT1_BASE_ADDR),
-			MX21_INT_GPT1);
+		       MX21_GPT1_BASE_ADDR, MX21_INT_GPT1);
 	return 0;
 }
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx2/clock_imx27.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx2/clock_imx27.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx2/clock_imx27.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx2/clock_imx27.c	2012-05-12 19:38:20.736576829 +0200
@@ -756,8 +756,7 @@
 #endif
 
 	mxc_timer_init(&gpt1_clk, MX27_IO_ADDRESS(MX27_GPT1_BASE_ADDR),
-			MX27_INT_GPT1);
+		       MX27_GPT1_BASE_ADDR, MX27_INT_GPT1);
 
 	return 0;
 }
-
diff -Naur linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx2/devices.c linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx2/devices.c
--- linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect1/arch/arm/mach-mx2/devices.c	2012-03-28 11:43:43.000000000 +0200
+++ linux-2.6-imx_rel_imx_2.6.35_11.01.00_mect2/arch/arm/mach-mx2/devices.c	2012-05-12 19:38:20.736576829 +0200
@@ -37,6 +37,7 @@
 #include <mach/hardware.h>
 #include <mach/common.h>
 #include <mach/mmc.h>
+#include <mach/mx27.h>
 
 #include "devices.h"
 
@@ -501,3 +502,13 @@
 };
 #endif
 
+#ifdef CONFIG_IPIPE
+static int post_cpu_init(void)
+{
+	if (cpu_is_mx27())
+		ipipe_mach_allow_hwtimer_uaccess(MX27_AIPI_BASE_ADDR_VIRT, 3);
+	return 0;
+}
+
+postcore_initcall(post_cpu_init);
+#endif /* CONFIG_IPIPE */
